/* unlimited distribution */

/* 2011-05-19 23:46:32 */

const char *name = "cavesplit";

#include <zlib.h>

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

unsigned char cave[2172];

int split(char *cave_name, char *base_name, char *work_name)
{
	int type = 0; /* determine the type of caves, used to format the output file names */
	int team;
	for(team = 0; team < 2; team++) { /* single player and teamwork are separate files, so need to read both */
		gzFile in_file;
		sprintf(work_name, "%s.%c", cave_name, team + 'S'); /* format of cave collection file names */
		if(in_file = gzopen(work_name, "rb"), in_file != 0) { /* use zlib to uncompress a cave collection */
			int level = 0;
			while(gzread(in_file, cave, sizeof(cave)) == sizeof(cave)) { /* read a level from the cave collection */
				FILE *out_file;

				int ver = 0; /* determine the version of the level */
				if(memcmp(cave + 2106, "\xea\x13\x18\x01", 4) == 0) ver = 3;
				if(memcmp(cave + 2106, "\x00\x00\x00\x00", 4) == 0) ver = 4;
				if(memcmp(cave + 2106, "\xff\x35\x30\x30", 4) == 0) ver = 5;
				if(memcmp(cave + 2106, "\xff\x36\x30\x30", 4) == 0) ver = 6;
				if(ver == 0) continue;

				if(type == 0) type = ver; /* output type is deduced from the first valid level */

				if(type == 6) {
					sprintf(work_name, "%s/%02d%c", base_name, level, team + 'S'); /* noi-ris level name */
				} else {
					sprintf(work_name, "%s/%d", base_name, team * 81 + level); /* original level name */
				}

				out_file = fopen(work_name, "wb"); /* create output level file */
				if(out_file == 0) { /* short circuit if output directory already exists */
					int i;
					for(i = 0; work_name[i]; i++) {
						if(work_name[i] == '/') { work_name[i] = 0; mkdir(work_name, 511); work_name[i] = '/'; } /* make leading directories */
					}
					out_file = fopen(work_name, "wb"); /* try again now the directories have been created */
				}
				if(out_file != 0) {
					int size = 2106; /* the size of the level depends on the version of the cave, not the overall cave type */
					if(ver == 5) size = 2110;
					if(ver == 6) size = 2172;
					if(fwrite(cave, size, 1, out_file) != 1) perror(work_name);
					if(fclose(out_file)) perror(work_name);
				} else perror(work_name);

				level++;
			}
			gzclose(in_file);
		} else if(type == 0) perror(work_name);
	}
	return(0);
}

int main(int argc, char **argv)
{
	int a;
	for(a = 1; a < argc; a++) {
		char *file = argv[a];
		int len = strlen(file);

		char *cave_name;
		if(cave_name = malloc(len + 20), cave_name != 0) {
			char *base_name;
			if(base_name = malloc(len + 20), base_name != 0) {
				char *work_name;
				if(work_name = malloc(len + 20), work_name != 0) {

					strcpy(cave_name, file);
					file = cave_name;
					if(len > 2 && file[len - 2] == '.' && (file[len - 1] == 'S' || file[len - 1] == 'T')) {
						file[len - 2] = 0;
					}
					file = strrchr(cave_name, '/');
					strcpy(base_name, (file == 0 ? cave_name : file + 1));

					fputs(base_name, stderr); putc(' ', stderr); fflush(stderr);

					split(cave_name, base_name, work_name);

					free(work_name);
				} else perror(name);
				free(base_name);
			} else perror(name);
			free(cave_name);
		} else perror(name);
	}
	if(argc < 2) {
		fputs("cavesplit 0.3 © David Tritscher"
#ifdef ZLIB_VERSION
		" [zlib]"
#endif
		"\n\n", stderr);
		fputs("usage: cavesplit [file...]\n\n", stderr);
		fputs("split X11 Emerald Mine caves into amiga Emerald Mine caves\n", stderr);
	}
	return(0);
}
