/* experimental rubbish'n'damaged graphics */

/* if you find the graphics are broken, the problem is in rocks'n'diamonds. see:
 *
 * <a href="http://www.catb.org/~esr/jargon/C/creeping-featurism.html">creeping featurism</a>
 * <a href="http://www.catb.org/~esr/jargon/B/bug-compatible.html">bug compatible</a>
 * <a href="http://www.catb.org/~esr/jargon/C/critical-mass.html">critical mass</a>
 */

/* ---------------------------------------------------------------------- */

/* THIS FILE AUTOMATICALLY GENERATED */

#include "emerald.h"

enum element {
	Mspace = 1,
	Msplash_e,
	Msplash_w,
	Mplant,
	Macid,
	Mgrass,
	Mdirt,
	Mandroid,
	Meater,
	Malien,
	Mbug,
	Mtank,
	Memerald,
	Mdiamond,
	Mstone,
	Mbomb,
	Mnut,
	Mspring,
	Mdynamite,
	Mkey_1,
	Mkey_2,
	Mkey_3,
	Mkey_4,
	Mkey_5,
	Mkey_6,
	Mkey_7,
	Mkey_8,
	Mdoor_1,
	Mdoor_2,
	Mdoor_3,
	Mdoor_4,
	Mdoor_5,
	Mdoor_6,
	Mdoor_7,
	Mdoor_8,
	Mfake_door_1,
	Mfake_door_2,
	Mfake_door_3,
	Mfake_door_4,
	Mfake_door_5,
	Mfake_door_6,
	Mfake_door_7,
	Mfake_door_8,
	Mballoon,
	Mball,
	Mameuba_1,
	Mameuba_2,
	Mdrip,
	Mwonderwall,
	Mwheel,
	Mswitch,
	Mbumper,
	Macid_s,
	Macid_nw,
	Macid_ne,
	Macid_sw,
	Macid_se,
	Mfake_space,
	Mfake_grass,
	Mfake_ameuba,
	Mlenses,
	Mmagnify,
	Msand,
	Mslide_ns,
	Mslide_ew,
	Mwind_n,
	Mwind_e,
	Mwind_s,
	Mwind_w,
	Mwind_multi,
	Mwind_stop,
	Mexit,
	Mexit_open,
	Mwall_1,
	Mwall_2,
	Mwall_3,
	Mwall_4,
	Mroundwall_1,
	Mroundwall_2,
	Mroundwall_3,
	Mroundwall_4,
	Msteel_1,
	Msteel_2,
	Msteel_3,
	Msteel_4,
	Mdecor_1,
	Mdecor_2,
	Mdecor_3,
	Mdecor_4,
	Mdecor_5,
	Mdecor_6,
	Mdecor_7,
	Mdecor_8,
	Mdecor_9,
	Mdecor_10,
	Mdecor_11,
	Mdecor_12,
	Malpha_excla,
	Malpha_apost,
	Malpha_comma,
	Malpha_minus,
	Malpha_perio,
	Malpha_colon,
	Malpha_quest,
	Malpha_arrow_e,
	Malpha_arrow_w,
	Malpha_copyr,
	Malpha_a,
	Malpha_b,
	Malpha_c,
	Malpha_d,
	Malpha_e,
	Malpha_f,
	Malpha_g,
	Malpha_h,
	Malpha_i,
	Malpha_j,
	Malpha_k,
	Malpha_l,
	Malpha_m,
	Malpha_n,
	Malpha_o,
	Malpha_p,
	Malpha_q,
	Malpha_r,
	Malpha_s,
	Malpha_t,
	Malpha_u,
	Malpha_v,
	Malpha_w,
	Malpha_x,
	Malpha_y,
	Malpha_z,
	Malpha_0,
	Malpha_1,
	Malpha_2,
	Malpha_3,
	Malpha_4,
	Malpha_5,
	Malpha_6,
	Malpha_7,
	Malpha_8,
	Malpha_9,
	Mboom,
	element_max
};
enum action {
	Ndig = 1,
	Nactive,
	Nmove,
	Nstone,
	Nspring,
	Nwest,
	Nnorth,
	Neast,
	Nsouth,
	Nfall,
	Nshine,
	Ncollect,
	Nactivate,
	Ncrack,
	Nslurp,
	Nother,
	Ngrow,
	Nsink,
	Nslip,
	Ndrop,
	Nexplode,
	action_max
};
enum direction {
	Onorth = 1,
	Oeast,
	Osouth,
	Owest,
	direction_max
};
enum parameter {
	Pposx = 1,
	Pposy,
	Pframes,
	Pdelay,
	Panim,
	Poffset,
	Psync,
	Pstride,
	parameter_max
};

const char *element_name[element_max] = {
	[Mspace] = "empty_space",
	[Msplash_e] = "acid_splash_right",
	[Msplash_w] = "acid_splash_left",
	[Mplant] = "emc_plant",
	[Macid] = "acid",
	[Mgrass] = "emc_grass",
	[Mdirt] = "sand",
	[Mandroid] = "emc_android",
	[Meater] = "yamyam",
	[Malien] = "robot",
	[Mbug] = "bug",
	[Mtank] = "spaceship",
	[Memerald] = "emerald",
	[Mdiamond] = "diamond",
	[Mstone] = "rock",
	[Mbomb] = "bomb",
	[Mnut] = "nut",
	[Mspring] = "spring",
	[Mdynamite] = "em_dynamite",
	[Mkey_1] = "em_key_1",
	[Mkey_2] = "em_key_2",
	[Mkey_3] = "em_key_3",
	[Mkey_4] = "em_key_4",
	[Mkey_5] = "emc_key_5",
	[Mkey_6] = "emc_key_6",
	[Mkey_7] = "emc_key_7",
	[Mkey_8] = "emc_key_8",
	[Mdoor_1] = "em_gate_1",
	[Mdoor_2] = "em_gate_2",
	[Mdoor_3] = "em_gate_3",
	[Mdoor_4] = "em_gate_4",
	[Mdoor_5] = "emc_gate_5",
	[Mdoor_6] = "emc_gate_6",
	[Mdoor_7] = "emc_gate_7",
	[Mdoor_8] = "emc_gate_8",
	[Mfake_door_1] = "em_gate_1_gray",
	[Mfake_door_2] = "em_gate_2_gray",
	[Mfake_door_3] = "em_gate_3_gray",
	[Mfake_door_4] = "em_gate_4_gray",
	[Mfake_door_5] = "emc_gate_5_gray",
	[Mfake_door_6] = "emc_gate_6_gray",
	[Mfake_door_7] = "emc_gate_7_gray",
	[Mfake_door_8] = "emc_gate_8_gray",
	[Mballoon] = "balloon",
	[Mball] = "emc_magic_ball",
	[Mameuba_1] = "amoeba_dry",
	[Mameuba_2] = "amoeba_wet",
	[Mdrip] = "amoeba_drop",
	[Mwonderwall] = "magic_wall",
	[Mwheel] = "robot_wheel",
	[Mswitch] = "emc_magic_ball_switch",
	[Mbumper] = "emc_spring_bumper",
	[Macid_s] = "acid_pool_bottom",
	[Macid_nw] = "acid_pool_topleft",
	[Macid_ne] = "acid_pool_topright",
	[Macid_sw] = "acid_pool_bottomleft",
	[Macid_se] = "acid_pool_bottomright",
	[Mfake_space] = "invisible_wall",
	[Mfake_grass] = "emc_fake_grass",
	[Mfake_ameuba] = "emc_dripper",
	[Mlenses] = "emc_lenses",
	[Mmagnify] = "emc_magnifier",
	[Msand] = "quicksand_empty",
	[Mslide_ns] = "expandable_wall_vertical",
	[Mslide_ew] = "expandable_wall_horizontal",
	[Mwind_n] = "balloon_switch_up",
	[Mwind_e] = "balloon_switch_right",
	[Mwind_s] = "balloon_switch_down",
	[Mwind_w] = "balloon_switch_left",
	[Mwind_multi] = "balloon_switch_any",
	[Mwind_stop] = "balloon_switch_none",
	[Mexit] = "em_exit_closed",
	[Mexit_open] = "em_exit_open",
	[Mwall_1] = "wall",
	[Mwall_2] = "emc_wall_14",
	[Mwall_3] = "emc_wall_15",
	[Mwall_4] = "emc_wall_16",
	[Mroundwall_1] = "wall_slippery",
	[Mroundwall_2] = "emc_wall_slippery_2",
	[Mroundwall_3] = "emc_wall_slippery_3",
	[Mroundwall_4] = "emc_wall_slippery_4",
	[Msteel_1] = "steelwall",
	[Msteel_2] = "emc_steelwall_2",
	[Msteel_3] = "emc_steelwall_3",
	[Msteel_4] = "emc_steelwall_4",
	[Mdecor_1] = "emc_wall_8",
	[Mdecor_2] = "emc_wall_6",
	[Mdecor_3] = "emc_wall_4",
	[Mdecor_4] = "emc_wall_7",
	[Mdecor_5] = "emc_wall_5",
	[Mdecor_6] = "emc_wall_9",
	[Mdecor_7] = "emc_wall_10",
	[Mdecor_8] = "emc_wall_1",
	[Mdecor_9] = "emc_wall_2",
	[Mdecor_10] = "emc_wall_3",
	[Mdecor_11] = "emc_wall_11",
	[Mdecor_12] = "emc_wall_12",
	[Malpha_excla] = "char_exclam",
	[Malpha_apost] = "char_quotedbl",
	[Malpha_comma] = "char_comma",
	[Malpha_minus] = "char_minus",
	[Malpha_perio] = "char_period",
	[Malpha_colon] = "char_colon",
	[Malpha_quest] = "char_question",
	[Malpha_arrow_e] = "char_greater",
	[Malpha_arrow_w] = "char_less",
	[Malpha_copyr] = "char_copyright",
	[Malpha_a] = "char_a",
	[Malpha_b] = "char_b",
	[Malpha_c] = "char_c",
	[Malpha_d] = "char_d",
	[Malpha_e] = "char_e",
	[Malpha_f] = "char_f",
	[Malpha_g] = "char_g",
	[Malpha_h] = "char_h",
	[Malpha_i] = "char_i",
	[Malpha_j] = "char_j",
	[Malpha_k] = "char_k",
	[Malpha_l] = "char_l",
	[Malpha_m] = "char_m",
	[Malpha_n] = "char_n",
	[Malpha_o] = "char_o",
	[Malpha_p] = "char_p",
	[Malpha_q] = "char_q",
	[Malpha_r] = "char_r",
	[Malpha_s] = "char_s",
	[Malpha_t] = "char_t",
	[Malpha_u] = "char_u",
	[Malpha_v] = "char_v",
	[Malpha_w] = "char_w",
	[Malpha_x] = "char_x",
	[Malpha_y] = "char_y",
	[Malpha_z] = "char_z",
	[Malpha_0] = "char_0",
	[Malpha_1] = "char_1",
	[Malpha_2] = "char_2",
	[Malpha_3] = "char_3",
	[Malpha_4] = "char_4",
	[Malpha_5] = "char_5",
	[Malpha_6] = "char_6",
	[Malpha_7] = "char_7",
	[Malpha_8] = "char_8",
	[Malpha_9] = "char_9",
	[Mboom] = "[default]",
};
const char *action_name[action_max] = {
	[Ndig] = ".digging",
	[Nactive] = ".active",
	[Nmove] = ".moving",
	[Nstone] = ".smashed_by_rock",
	[Nspring] = ".smashed_by_spring",
	[Nwest] = ".turning_from_left",
	[Nnorth] = ".turning_from_up",
	[Neast] = ".turning_from_right",
	[Nsouth] = ".turning_from_down",
	[Nfall] = ".falling",
	[Nshine] = ".twinkling",
	[Ncollect] = ".collecting",
	[Nactivate] = ".activating",
	[Ncrack] = ".breaking",
	[Nslurp] = ".eating",
	[Nother] = ".other",
	[Ngrow] = ".growing",
	[Nsink] = ".filling",
	[Nslip] = ".emptying",
	[Ndrop] = ".dropping",
	[Nexplode] = ".exploding",
};
const char *direction_name[direction_max] = {
	[Onorth] = ".up",
	[Oeast] = ".right",
	[Osouth] = ".down",
	[Owest] = ".left",
};
const char *parameter_name[parameter_max] = {
	[Pposx] = ".xpos",
	[Pposy] = ".ypos",
	[Pframes] = ".frames",
	[Pdelay] = ".delay",
	[Panim] = ".anim_mode",
	[Poffset] = ".offset",
	[Psync] = ".global_sync",
	[Pstride] = ".frames_per_line",
};

const short graphics_name[XMAX][3] = {
	[Xspace] = { Mspace, 0, 0 },
	[Xsplash_e] = { Msplash_e, 0, 0 },
	[Xsplash_w] = { Msplash_w, 0, 0 },
	[Xplant] = { Mplant, 0, 0 },
	[Yplant] = { Mplant, 0, 0 },
	[Xacid_1] = { Macid, 0, 0 },
	[Xacid_2] = { Macid, 0, 0 },
	[Xacid_3] = { Macid, 0, 0 },
	[Xacid_4] = { Macid, 0, 0 },
	[Xacid_5] = { Macid, 0, 0 },
	[Xacid_6] = { Macid, 0, 0 },
	[Xacid_7] = { Macid, 0, 0 },
	[Xacid_8] = { Macid, 0, 0 },
	[Xgrass] = { Mgrass, 0, 0 },
	[Ygrass_nB] = { Mgrass, Ndig, Onorth },
	[Ygrass_eB] = { Mgrass, Ndig, Oeast },
	[Ygrass_sB] = { Mgrass, Ndig, Osouth },
	[Ygrass_wB] = { Mgrass, Ndig, Owest },
	[Xdirt] = { Mdirt, 0, 0 },
	[Ydirt_nB] = { Mdirt, Ndig, Onorth },
	[Ydirt_eB] = { Mdirt, Ndig, Oeast },
	[Ydirt_sB] = { Mdirt, Ndig, Osouth },
	[Ydirt_wB] = { Mdirt, Ndig, Owest },
	[Xandroid] = { Mandroid, Nactive, 0 },
	[Xandroid_1_n] = { Mandroid, Nactive, Onorth },
	[Xandroid_2_n] = { Mandroid, Nactive, Onorth },
	[Xandroid_1_e] = { Mandroid, Nactive, Oeast },
	[Xandroid_2_e] = { Mandroid, Nactive, Oeast },
	[Xandroid_1_w] = { Mandroid, Nactive, Owest },
	[Xandroid_2_w] = { Mandroid, Nactive, Owest },
	[Xandroid_1_s] = { Mandroid, Nactive, Osouth },
	[Xandroid_2_s] = { Mandroid, Nactive, Osouth },
	[Yandroid_n] = { Mandroid, Nmove, Onorth },
	[Yandroid_nB] = { Mandroid, Nmove, Onorth },
	[Yandroid_ne] = { Mandroid, Nmove, Onorth },
	[Yandroid_neB] = { Mandroid, Nmove, Onorth },
	[Yandroid_e] = { Mandroid, Nmove, Oeast },
	[Yandroid_eB] = { Mandroid, Nmove, Oeast },
	[Yandroid_se] = { Mandroid, Nmove, Oeast },
	[Yandroid_seB] = { Mandroid, Nmove, Oeast },
	[Yandroid_s] = { Mandroid, Nmove, Osouth },
	[Yandroid_sB] = { Mandroid, Nmove, Osouth },
	[Yandroid_sw] = { Mandroid, Nmove, Osouth },
	[Yandroid_swB] = { Mandroid, Nmove, Osouth },
	[Yandroid_w] = { Mandroid, Nmove, Owest },
	[Yandroid_wB] = { Mandroid, Nmove, Owest },
	[Yandroid_nw] = { Mandroid, Nmove, Owest },
	[Yandroid_nwB] = { Mandroid, Nmove, Owest },
	[Xeater_n] = { Meater, 0, Onorth },
	[Xeater_e] = { Meater, 0, Oeast },
	[Xeater_s] = { Meater, 0, Osouth },
	[Xeater_w] = { Meater, 0, Owest },
	[Yeater_n] = { Meater, Nmove, Onorth },
	[Yeater_nB] = { Meater, Nmove, Onorth },
	[Yeater_e] = { Meater, Nmove, Oeast },
	[Yeater_eB] = { Meater, Nmove, Oeast },
	[Yeater_s] = { Meater, Nmove, Osouth },
	[Yeater_sB] = { Meater, Nmove, Osouth },
	[Yeater_w] = { Meater, Nmove, Owest },
	[Yeater_wB] = { Meater, Nmove, Owest },
	[Yeater_stone] = { Meater, Nstone, 0 },
	[Yeater_spring] = { Meater, Nspring, 0 },
	[Xalien] = { Malien, 0, 0 },
	[Xalien_pause] = { Malien, 0, 0 },
	[Yalien_n] = { Malien, Nmove, Onorth },
	[Yalien_nB] = { Malien, Nmove, Onorth },
	[Yalien_e] = { Malien, Nmove, Oeast },
	[Yalien_eB] = { Malien, Nmove, Oeast },
	[Yalien_s] = { Malien, Nmove, Osouth },
	[Yalien_sB] = { Malien, Nmove, Osouth },
	[Yalien_w] = { Malien, Nmove, Owest },
	[Yalien_wB] = { Malien, Nmove, Owest },
	[Yalien_stone] = { Malien, Nstone, 0 },
	[Yalien_spring] = { Malien, Nspring, 0 },
	[Xbug_1_n] = { Mbug, 0, Onorth },
	[Xbug_2_n] = { Mbug, 0, Onorth },
	[Xbug_1_e] = { Mbug, 0, Oeast },
	[Xbug_2_e] = { Mbug, 0, Oeast },
	[Xbug_1_s] = { Mbug, 0, Osouth },
	[Xbug_2_s] = { Mbug, 0, Osouth },
	[Xbug_1_w] = { Mbug, 0, Owest },
	[Xbug_2_w] = { Mbug, 0, Owest },
	[Ybug_n] = { Mbug, Nmove, Onorth },
	[Ybug_nB] = { Mbug, Nmove, Onorth },
	[Ybug_e] = { Mbug, Nmove, Oeast },
	[Ybug_eB] = { Mbug, Nmove, Oeast },
	[Ybug_s] = { Mbug, Nmove, Osouth },
	[Ybug_sB] = { Mbug, Nmove, Osouth },
	[Ybug_w] = { Mbug, Nmove, Owest },
	[Ybug_wB] = { Mbug, Nmove, Owest },
	[Ybug_w_n] = { Mbug, Nwest, Onorth },
	[Ybug_n_e] = { Mbug, Nnorth, Oeast },
	[Ybug_e_s] = { Mbug, Neast, Osouth },
	[Ybug_s_w] = { Mbug, Nsouth, Owest },
	[Ybug_e_n] = { Mbug, Neast, Onorth },
	[Ybug_s_e] = { Mbug, Nsouth, Oeast },
	[Ybug_w_s] = { Mbug, Nwest, Osouth },
	[Ybug_n_w] = { Mbug, Nnorth, Owest },
	[Ybug_stone_n] = { Mbug, Nstone, 0 },
	[Ybug_stone_e] = { Mbug, Nstone, 0 },
	[Ybug_stone_s] = { Mbug, Nstone, 0 },
	[Ybug_stone_w] = { Mbug, Nstone, 0 },
	[Ybug_spring_n] = { Mbug, Nspring, 0 },
	[Ybug_spring_e] = { Mbug, Nspring, 0 },
	[Ybug_spring_s] = { Mbug, Nspring, 0 },
	[Ybug_spring_w] = { Mbug, Nspring, 0 },
	[Xtank_1_n] = { Mtank, 0, Onorth },
	[Xtank_2_n] = { Mtank, 0, Onorth },
	[Xtank_1_e] = { Mtank, 0, Oeast },
	[Xtank_2_e] = { Mtank, 0, Oeast },
	[Xtank_1_s] = { Mtank, 0, Osouth },
	[Xtank_2_s] = { Mtank, 0, Osouth },
	[Xtank_1_w] = { Mtank, 0, Owest },
	[Xtank_2_w] = { Mtank, 0, Owest },
	[Ytank_n] = { Mtank, Nmove, Onorth },
	[Ytank_nB] = { Mtank, Nmove, Onorth },
	[Ytank_e] = { Mtank, Nmove, Oeast },
	[Ytank_eB] = { Mtank, Nmove, Oeast },
	[Ytank_s] = { Mtank, Nmove, Osouth },
	[Ytank_sB] = { Mtank, Nmove, Osouth },
	[Ytank_w] = { Mtank, Nmove, Owest },
	[Ytank_wB] = { Mtank, Nmove, Owest },
	[Ytank_w_n] = { Mtank, Nwest, Onorth },
	[Ytank_n_e] = { Mtank, Nnorth, Oeast },
	[Ytank_e_s] = { Mtank, Neast, Osouth },
	[Ytank_s_w] = { Mtank, Nsouth, Owest },
	[Ytank_e_n] = { Mtank, Neast, Onorth },
	[Ytank_s_e] = { Mtank, Nsouth, Oeast },
	[Ytank_w_s] = { Mtank, Nwest, Osouth },
	[Ytank_n_w] = { Mtank, Nnorth, Owest },
	[Ytank_stone_n] = { Mtank, Nstone, 0 },
	[Ytank_stone_e] = { Mtank, Nstone, 0 },
	[Ytank_stone_s] = { Mtank, Nstone, 0 },
	[Ytank_stone_w] = { Mtank, Nstone, 0 },
	[Ytank_spring_n] = { Mtank, Nspring, 0 },
	[Ytank_spring_e] = { Mtank, Nspring, 0 },
	[Ytank_spring_s] = { Mtank, Nspring, 0 },
	[Ytank_spring_w] = { Mtank, Nspring, 0 },
	[Xemerald] = { Memerald, 0, 0 },
	[Xemerald_pause] = { Memerald, 0, 0 },
	[Xemerald_fall] = { Memerald, 0, 0 },
	[Yemerald_s] = { Memerald, Nfall, 0 },
	[Yemerald_sB] = { Memerald, Nfall, 0 },
	[Yemerald_e] = { Memerald, Nmove, Oeast },
	[Yemerald_eB] = { Memerald, Nmove, Oeast },
	[Yemerald_w] = { Memerald, Nmove, Owest },
	[Yemerald_wB] = { Memerald, Nmove, Owest },
	[Yemerald_shine] = { Memerald, Nshine, 0 },
	[Yemerald_space] = { Memerald, Ncollect, 0 },
	[Xdiamond] = { Mdiamond, 0, 0 },
	[Xdiamond_pause] = { Mdiamond, 0, 0 },
	[Xdiamond_fall] = { Mdiamond, 0, 0 },
	[Ydiamond_s] = { Mdiamond, Nfall, 0 },
	[Ydiamond_sB] = { Mdiamond, Nfall, 0 },
	[Ydiamond_e] = { Mdiamond, Nmove, Oeast },
	[Ydiamond_eB] = { Mdiamond, Nmove, Oeast },
	[Ydiamond_w] = { Mdiamond, Nmove, Owest },
	[Ydiamond_wB] = { Mdiamond, Nmove, Owest },
	[Ydiamond_shine] = { Mdiamond, Nshine, 0 },
	[Ydiamond_space] = { Mdiamond, Ncollect, 0 },
	[Ydiamond_stone] = { Mdiamond, Nstone, 0 },
	[Xstone] = { Mstone, 0, 0 },
	[Xstone_pause] = { Mstone, 0, 0 },
	[Xstone_fall] = { Mstone, 0, 0 },
	[Ystone_s] = { Mstone, Nfall, 0 },
	[Ystone_sB] = { Mstone, Nfall, 0 },
	[Ystone_e] = { Mstone, Nmove, Oeast },
	[Ystone_eB] = { Mstone, Nmove, Oeast },
	[Ystone_w] = { Mstone, Nmove, Owest },
	[Ystone_wB] = { Mstone, Nmove, Owest },
	[Xbomb] = { Mbomb, 0, 0 },
	[Xbomb_pause] = { Mbomb, 0, 0 },
	[Xbomb_fall] = { Mbomb, 0, 0 },
	[Ybomb_s] = { Mbomb, Nfall, 0 },
	[Ybomb_sB] = { Mbomb, Nfall, 0 },
	[Ybomb_e] = { Mbomb, Nmove, Oeast },
	[Ybomb_eB] = { Mbomb, Nmove, Oeast },
	[Ybomb_w] = { Mbomb, Nmove, Owest },
	[Ybomb_wB] = { Mbomb, Nmove, Owest },
	[Ybomb_space] = { Mbomb, Nactivate, 0 },
	[Xnut] = { Mnut, 0, 0 },
	[Xnut_pause] = { Mnut, 0, 0 },
	[Xnut_fall] = { Mnut, 0, 0 },
	[Ynut_s] = { Mnut, Nfall, 0 },
	[Ynut_sB] = { Mnut, Nfall, 0 },
	[Ynut_e] = { Mnut, Nmove, Oeast },
	[Ynut_eB] = { Mnut, Nmove, Oeast },
	[Ynut_w] = { Mnut, Nmove, Owest },
	[Ynut_wB] = { Mnut, Nmove, Owest },
	[Ynut_stone] = { Mnut, Ncrack, 0 },
	[Xspring] = { Mspring, 0, 0 },
	[Xspring_pause] = { Mspring, 0, 0 },
	[Xspring_fall] = { Mspring, 0, 0 },
	[Xspring_e] = { Mspring, 0, 0 },
	[Xspring_w] = { Mspring, 0, 0 },
	[Yspring_s] = { Mspring, Nfall, 0 },
	[Yspring_sB] = { Mspring, Nfall, 0 },
	[Yspring_e] = { Mspring, Nmove, Oeast },
	[Yspring_eB] = { Mspring, Nmove, Oeast },
	[Yspring_w] = { Mspring, Nmove, Owest },
	[Yspring_wB] = { Mspring, Nmove, Owest },
	[Yspring_alien_e] = { Mspring, Nslurp, Oeast },
	[Yspring_alien_eB] = { Mspring, Nslurp, Oeast },
	[Yspring_alien_w] = { Mspring, Nslurp, Owest },
	[Yspring_alien_wB] = { Mspring, Nslurp, Owest },
	[Xpush_emerald_e] = { Memerald, 0, Oeast },
	[Xpush_emerald_w] = { Memerald, 0, Owest },
	[Xpush_diamond_e] = { Mdiamond, 0, Oeast },
	[Xpush_diamond_w] = { Mdiamond, 0, Owest },
	[Xpush_stone_e] = { Mstone, 0, Oeast },
	[Xpush_stone_w] = { Mstone, 0, Owest },
	[Xpush_bomb_e] = { Mbomb, 0, Oeast },
	[Xpush_bomb_w] = { Mbomb, 0, Owest },
	[Xpush_nut_e] = { Mnut, 0, Oeast },
	[Xpush_nut_w] = { Mnut, 0, Owest },
	[Xpush_spring_e] = { Mspring, 0, Oeast },
	[Xpush_spring_w] = { Mspring, 0, Owest },
	[Xdynamite] = { Mdynamite, 0, 0 },
	[Ydynamite_space] = { Mdynamite, Ncollect, 0 },
	[Xdynamite_1] = { Mdynamite, Nactive, 0 },
	[Xdynamite_2] = { Mdynamite, Nactive, 0 },
	[Xdynamite_3] = { Mdynamite, Nactive, 0 },
	[Xdynamite_4] = { Mdynamite, Nactive, 0 },
	[Xkey_1] = { Mkey_1, 0, 0 },
	[Xkey_2] = { Mkey_2, 0, 0 },
	[Xkey_3] = { Mkey_3, 0, 0 },
	[Xkey_4] = { Mkey_4, 0, 0 },
	[Xkey_5] = { Mkey_5, 0, 0 },
	[Xkey_6] = { Mkey_6, 0, 0 },
	[Xkey_7] = { Mkey_7, 0, 0 },
	[Xkey_8] = { Mkey_8, 0, 0 },
	[Xdoor_1] = { Mdoor_1, 0, 0 },
	[Xdoor_2] = { Mdoor_2, 0, 0 },
	[Xdoor_3] = { Mdoor_3, 0, 0 },
	[Xdoor_4] = { Mdoor_4, 0, 0 },
	[Xdoor_5] = { Mdoor_5, 0, 0 },
	[Xdoor_6] = { Mdoor_6, 0, 0 },
	[Xdoor_7] = { Mdoor_7, 0, 0 },
	[Xdoor_8] = { Mdoor_8, 0, 0 },
	[Xfake_door_1] = { Mfake_door_1, 0, 0 },
	[Xfake_door_2] = { Mfake_door_2, 0, 0 },
	[Xfake_door_3] = { Mfake_door_3, 0, 0 },
	[Xfake_door_4] = { Mfake_door_4, 0, 0 },
	[Xfake_door_5] = { Mfake_door_5, 0, 0 },
	[Xfake_door_6] = { Mfake_door_6, 0, 0 },
	[Xfake_door_7] = { Mfake_door_7, 0, 0 },
	[Xfake_door_8] = { Mfake_door_8, 0, 0 },
	[Xballoon] = { Mballoon, 0, 0 },
	[Yballoon_n] = { Mballoon, Nmove, Onorth },
	[Yballoon_nB] = { Mballoon, Nmove, Onorth },
	[Yballoon_e] = { Mballoon, Nmove, Oeast },
	[Yballoon_eB] = { Mballoon, Nmove, Oeast },
	[Yballoon_s] = { Mballoon, Nmove, Osouth },
	[Yballoon_sB] = { Mballoon, Nmove, Osouth },
	[Yballoon_w] = { Mballoon, Nmove, Owest },
	[Yballoon_wB] = { Mballoon, Nmove, Owest },
	[Xball_1] = { Mball, 0, 0 },
	[Xball_2] = { Mball, 0, 0 },
	[Yball_1] = { Mball, Nactive, 0 },
	[Yball_2] = { Mball, Nactive, 0 },
	[Xameuba_1] = { Mameuba_1, Nother, 0 },
	[Xameuba_2] = { Mameuba_1, Nother, 0 },
	[Xameuba_3] = { Mameuba_1, Nother, 0 },
	[Xameuba_4] = { Mameuba_1, Nother, 0 },
	[Xameuba_5] = { Mameuba_2, Nother, 0 },
	[Xameuba_6] = { Mameuba_2, Nother, 0 },
	[Xameuba_7] = { Mameuba_2, Nother, 0 },
	[Xameuba_8] = { Mameuba_2, Nother, 0 },
	[Xdrip] = { Mdrip, Ngrow, 0 },
	[Xdrip_1_sB] = { Mdrip, Nfall, 0 },
	[Xdrip_2_sB] = { Mdrip, Nfall, 0 },
	[Xdrip_1_s] = { Mdrip, Nfall, 0 },
	[Xdrip_2_s] = { Mdrip, Nfall, 0 },
	[Xwonderwall] = { Mwonderwall, 0, 0 },
	[Ywonderwall] = { Mwonderwall, Nactive, 0 },
	[Xwheel] = { Mwheel, 0, 0 },
	[Ywheel] = { Mwheel, Nactive, 0 },
	[Xswitch] = { Mswitch, 0, 0 },
	[Yswitch] = { Mswitch, Nactive, 0 },
	[Xbumper] = { Mbumper, 0, 0 },
	[Ybumper] = { Mbumper, Nactive, 0 },
	[Xacid_s] = { Macid_s, 0, 0 },
	[Xacid_nw] = { Macid_nw, 0, 0 },
	[Xacid_ne] = { Macid_ne, 0, 0 },
	[Xacid_sw] = { Macid_sw, 0, 0 },
	[Xacid_se] = { Macid_se, 0, 0 },
	[Xfake_space] = { Mfake_space, 0, 0 },
	[Yfake_space] = { Mfake_space, Nactive, 0 },
	[Xfake_grass] = { Mfake_grass, 0, 0 },
	[Yfake_grass] = { Mfake_grass, Nactive, 0 },
	[Xfake_ameuba] = { Mfake_ameuba, 0, 0 },
	[Yfake_ameuba] = { Mfake_ameuba, Nactive, 0 },
	[Xlenses] = { Mlenses, 0, 0 },
	[Xmagnify] = { Mmagnify, 0, 0 },
	[Xsand] = { Msand, 0, 0 },
	[Xsand_stone] = { Msand, 0, 0 },
	[Xsand_stone_1_sB] = { Mstone, Nsink, 0 },
	[Xsand_stone_2_sB] = { Mstone, Nsink, 0 },
	[Xsand_stone_3_sB] = { Mstone, Nsink, 0 },
	[Xsand_stone_4_sB] = { Mstone, Nsink, 0 },
	[Xsand_sand_1_s] = { Msand, 0, 0 },
	[Xsand_sand_2_s] = { Msand, 0, 0 },
	[Xsand_sand_3_s] = { Msand, 0, 0 },
	[Xsand_sand_4_s] = { Msand, 0, 0 },
	[Xsand_sand_1_sB] = { Msand, 0, 0 },
	[Xsand_sand_2_sB] = { Msand, 0, 0 },
	[Xsand_sand_3_sB] = { Msand, 0, 0 },
	[Xsand_sand_4_sB] = { Msand, 0, 0 },
	[Xsand_stone_1_s] = { Mstone, Nslip, 0 },
	[Xsand_stone_2_s] = { Mstone, Nslip, 0 },
	[Xslide_ns] = { Mslide_ns, 0, 0 },
	[Xslide_ew] = { Mslide_ew, 0, 0 },
	[Yslide_ns] = { Mslide_ns, Ngrow, 0 },
	[Yslide_ew] = { Mslide_ew, Ngrow, 0 },
	[Xwind_n] = { Mwind_n, 0, 0 },
	[Xwind_e] = { Mwind_e, 0, 0 },
	[Xwind_s] = { Mwind_s, 0, 0 },
	[Xwind_w] = { Mwind_w, 0, 0 },
	[Xwind_multi] = { Mwind_multi, 0, 0 },
	[Xwind_stop] = { Mwind_stop, 0, 0 },
	[Xexit] = { Mexit, 0, 0 },
	[Xexit_1] = { Mexit_open, 0, 0 },
	[Xexit_2] = { Mexit_open, 0, 0 },
	[Xexit_3] = { Mexit_open, 0, 0 },
	[Xpause] = { Mball, Ndrop, 0 },
	[Xwall_1] = { Mwall_1, 0, 0 },
	[Xwall_2] = { Mwall_2, 0, 0 },
	[Xwall_3] = { Mwall_3, 0, 0 },
	[Xwall_4] = { Mwall_4, 0, 0 },
	[Xroundwall_1] = { Mroundwall_1, 0, 0 },
	[Xroundwall_2] = { Mroundwall_2, 0, 0 },
	[Xroundwall_3] = { Mroundwall_3, 0, 0 },
	[Xroundwall_4] = { Mroundwall_4, 0, 0 },
	[Xsteel_1] = { Msteel_1, 0, 0 },
	[Xsteel_2] = { Msteel_2, 0, 0 },
	[Xsteel_3] = { Msteel_3, 0, 0 },
	[Xsteel_4] = { Msteel_4, 0, 0 },
	[Xdecor_1] = { Mdecor_1, 0, 0 },
	[Xdecor_2] = { Mdecor_2, 0, 0 },
	[Xdecor_3] = { Mdecor_3, 0, 0 },
	[Xdecor_4] = { Mdecor_4, 0, 0 },
	[Xdecor_5] = { Mdecor_5, 0, 0 },
	[Xdecor_6] = { Mdecor_6, 0, 0 },
	[Xdecor_7] = { Mdecor_7, 0, 0 },
	[Xdecor_8] = { Mdecor_8, 0, 0 },
	[Xdecor_9] = { Mdecor_9, 0, 0 },
	[Xdecor_10] = { Mdecor_10, 0, 0 },
	[Xdecor_11] = { Mdecor_11, 0, 0 },
	[Xdecor_12] = { Mdecor_12, 0, 0 },
	[Xalpha_excla] = { Malpha_excla, 0, 0 },
	[Xalpha_apost] = { Malpha_apost, 0, 0 },
	[Xalpha_comma] = { Malpha_comma, 0, 0 },
	[Xalpha_minus] = { Malpha_minus, 0, 0 },
	[Xalpha_perio] = { Malpha_perio, 0, 0 },
	[Xalpha_colon] = { Malpha_colon, 0, 0 },
	[Xalpha_quest] = { Malpha_quest, 0, 0 },
	[Xalpha_arrow_e] = { Malpha_arrow_e, 0, 0 },
	[Xalpha_arrow_w] = { Malpha_arrow_w, 0, 0 },
	[Xalpha_copyr] = { Malpha_copyr, 0, 0 },
	[Xalpha_a] = { Malpha_a, 0, 0 },
	[Xalpha_b] = { Malpha_b, 0, 0 },
	[Xalpha_c] = { Malpha_c, 0, 0 },
	[Xalpha_d] = { Malpha_d, 0, 0 },
	[Xalpha_e] = { Malpha_e, 0, 0 },
	[Xalpha_f] = { Malpha_f, 0, 0 },
	[Xalpha_g] = { Malpha_g, 0, 0 },
	[Xalpha_h] = { Malpha_h, 0, 0 },
	[Xalpha_i] = { Malpha_i, 0, 0 },
	[Xalpha_j] = { Malpha_j, 0, 0 },
	[Xalpha_k] = { Malpha_k, 0, 0 },
	[Xalpha_l] = { Malpha_l, 0, 0 },
	[Xalpha_m] = { Malpha_m, 0, 0 },
	[Xalpha_n] = { Malpha_n, 0, 0 },
	[Xalpha_o] = { Malpha_o, 0, 0 },
	[Xalpha_p] = { Malpha_p, 0, 0 },
	[Xalpha_q] = { Malpha_q, 0, 0 },
	[Xalpha_r] = { Malpha_r, 0, 0 },
	[Xalpha_s] = { Malpha_s, 0, 0 },
	[Xalpha_t] = { Malpha_t, 0, 0 },
	[Xalpha_u] = { Malpha_u, 0, 0 },
	[Xalpha_v] = { Malpha_v, 0, 0 },
	[Xalpha_w] = { Malpha_w, 0, 0 },
	[Xalpha_x] = { Malpha_x, 0, 0 },
	[Xalpha_y] = { Malpha_y, 0, 0 },
	[Xalpha_z] = { Malpha_z, 0, 0 },
	[Xalpha_0] = { Malpha_0, 0, 0 },
	[Xalpha_1] = { Malpha_1, 0, 0 },
	[Xalpha_2] = { Malpha_2, 0, 0 },
	[Xalpha_3] = { Malpha_3, 0, 0 },
	[Xalpha_4] = { Malpha_4, 0, 0 },
	[Xalpha_5] = { Malpha_5, 0, 0 },
	[Xalpha_6] = { Malpha_6, 0, 0 },
	[Xalpha_7] = { Malpha_7, 0, 0 },
	[Xalpha_8] = { Malpha_8, 0, 0 },
	[Xalpha_9] = { Malpha_9, 0, 0 },
	[Xchain] = { Mboom, Nexplode, 0 },
	[Xboom_android] = { Mandroid, Nother, 0 },
	[Xboom_1] = { Mboom, Nexplode, 0 },
	[Xboom_2] = { Mboom, Nexplode, 0 },
	[Xpop] = { Mball, Ndrop, 0 },
};

const char *sounds_name[SOUND_MAX] = {
	[SOUND_exit] = "[exit].passing",
	[SOUND_die] = "[default].dying",
	[SOUND_time] = "game.running_out_of_time",
	[SOUND_boom] = "[default].exploding",
	[SOUND_tick] = "[dynamite].active",
	[SOUND_collect] = "diamond.collecting",
	[SOUND_roll] = "rock.pushing",
	[SOUND_push] = "balloon.pushing",
	[SOUND_dynamite] = "[dynamite].dropping",
	[SOUND_press] = "robot_wheel.activating",
	[SOUND_door] = "[gate].passing",
	[SOUND_dirt] = "sand.digging",
	[SOUND_space] = "[default].walking",
	[SOUND_android] = "emc_android.dropping",
	[SOUND_ball] = "emc_magic_ball.dropping",
	[SOUND_slide] = "[wall].growing",
	[SOUND_squash] = "diamond.breaking",
	[SOUND_crack] = "nut.breaking",
	[SOUND_slurp] = "spring.eating",
	[SOUND_drip] = "[amoeba].growing",
	[SOUND_wonder] = "magic_wall.active",
	[SOUND_wheel] = "robot_wheel.active",
	[SOUND_stone] = "rock.impact",
	[SOUND_spring] = "spring.impact",
	[SOUND_diamond] = "diamond.impact",
	[SOUND_nut] = "nut.impact",
	[SOUND_bug] = "bug.moving",
	[SOUND_tank] = "spaceship.moving",
	[SOUND_eater] = "yamyam.digging",
	[SOUND_alien] = "robot.moving",
	[SOUND_acid] = "acid.splashing",
};

enum mode {
	Qloop,
	Qloop_reverse,
	Qlinear,
	Qlinear_reverse,
	Qpingpong,
	Qpingpong2,
	Qrandom,
	mode_max
};

enum movement {
	Rhalf = 1 << 5,
	Rquarter = 1 << 6,
	Rspace = 1 << 7,
	Rnorth = 1 << 8,
	Reast = 1 << 9,
	Rsouth = 1 << 10,
	Rwest = 1 << 11,
};
const short anim_movement[XMAX] = {
	[Yandroid_n] = Rnorth,
	[Yandroid_nB] = Rnorth + Rspace,
	[Yandroid_ne] = Rnorth + Reast,
	[Yandroid_neB] = Rnorth + Reast + Rspace,
	[Yandroid_e] = Reast,
	[Yandroid_eB] = Reast + Rspace,
	[Yandroid_se] = Rsouth + Reast,
	[Yandroid_seB] = Rsouth + Reast + Rspace,
	[Yandroid_s] = Rsouth,
	[Yandroid_sB] = Rsouth + Rspace,
	[Yandroid_sw] = Rsouth + Rwest,
	[Yandroid_swB] = Rsouth + Rwest + Rspace,
	[Yandroid_w] = Rwest,
	[Yandroid_wB] = Rwest + Rspace,
	[Yandroid_nw] = Rnorth + Rwest,
	[Yandroid_nwB] = Rnorth + Rwest + Rspace,
	[Yeater_n] = Rnorth,
	[Yeater_nB] = Rnorth + Rspace,
	[Yeater_e] = Reast,
	[Yeater_eB] = Reast + Rspace,
	[Yeater_s] = Rsouth,
	[Yeater_sB] = Rsouth + Rspace,
	[Yeater_w] = Rwest,
	[Yeater_wB] = Rwest + Rspace,
	[Yalien_n] = Rnorth,
	[Yalien_nB] = Rnorth + Rspace,
	[Yalien_e] = Reast,
	[Yalien_eB] = Reast + Rspace,
	[Yalien_s] = Rsouth,
	[Yalien_sB] = Rsouth + Rspace,
	[Yalien_w] = Rwest,
	[Yalien_wB] = Rwest + Rspace,
	[Ybug_n] = Rnorth,
	[Ybug_nB] = Rnorth + Rspace,
	[Ybug_e] = Reast,
	[Ybug_eB] = Reast + Rspace,
	[Ybug_s] = Rsouth,
	[Ybug_sB] = Rsouth + Rspace,
	[Ybug_w] = Rwest,
	[Ybug_wB] = Rwest + Rspace,
	[Ytank_n] = Rnorth,
	[Ytank_nB] = Rnorth + Rspace,
	[Ytank_e] = Reast,
	[Ytank_eB] = Reast + Rspace,
	[Ytank_s] = Rsouth,
	[Ytank_sB] = Rsouth + Rspace,
	[Ytank_w] = Rwest,
	[Ytank_wB] = Rwest + Rspace,
	[Yemerald_s] = Rsouth,
	[Yemerald_sB] = Rsouth + Rspace,
	[Yemerald_e] = Reast,
	[Yemerald_eB] = Reast + Rspace,
	[Yemerald_w] = Rwest,
	[Yemerald_wB] = Rwest + Rspace,
	[Ydiamond_s] = Rsouth,
	[Ydiamond_sB] = Rsouth + Rspace,
	[Ydiamond_e] = Reast,
	[Ydiamond_eB] = Reast + Rspace,
	[Ydiamond_w] = Rwest,
	[Ydiamond_wB] = Rwest + Rspace,
	[Ystone_s] = Rsouth,
	[Ystone_sB] = Rsouth + Rspace,
	[Ystone_e] = Reast,
	[Ystone_eB] = Reast + Rspace,
	[Ystone_w] = Rwest,
	[Ystone_wB] = Rwest + Rspace,
	[Ybomb_s] = Rsouth,
	[Ybomb_sB] = Rsouth + Rspace,
	[Ybomb_e] = Reast,
	[Ybomb_eB] = Reast + Rspace,
	[Ybomb_w] = Rwest,
	[Ybomb_wB] = Rwest + Rspace,
	[Ynut_s] = Rsouth,
	[Ynut_sB] = Rsouth + Rspace,
	[Ynut_e] = Reast,
	[Ynut_eB] = Reast + Rspace,
	[Ynut_w] = Rwest,
	[Ynut_wB] = Rwest + Rspace,
	[Yspring_s] = Rsouth,
	[Yspring_sB] = Rsouth + Rspace,
	[Yspring_e] = Reast,
	[Yspring_eB] = Reast + Rspace,
	[Yspring_w] = Rwest,
	[Yspring_wB] = Rwest + Rspace,
	[Yspring_alien_e] = Reast,
	[Yspring_alien_eB] = Reast + Rspace,
	[Yspring_alien_w] = Rwest,
	[Yspring_alien_wB] = Rwest + Rspace,
	[Yballoon_n] = Rnorth,
	[Yballoon_nB] = Rnorth + Rspace,
	[Yballoon_e] = Reast,
	[Yballoon_eB] = Reast + Rspace,
	[Yballoon_s] = Rsouth,
	[Yballoon_sB] = Rsouth + Rspace,
	[Yballoon_w] = Rwest,
	[Yballoon_wB] = Rwest + Rspace,
	[Xdrip_1_sB] = Rsouth + Rspace + Rhalf + 0,
	[Xdrip_2_sB] = Rsouth + Rspace + Rhalf + 1,
	[Xdrip_1_s] = Rsouth + Rhalf + 0,
	[Xdrip_2_s] = Rsouth + Rhalf + 1,
	[Xsand_stone_1_sB] = Rsouth + Rspace + Rquarter + 0,
	[Xsand_stone_2_sB] = Rsouth + Rspace + Rquarter + 1,
	[Xsand_stone_3_sB] = Rsouth + Rspace + Rquarter + 2,
	[Xsand_stone_4_sB] = Rsouth + Rspace + Rquarter + 3,
	[Xsand_stone_1_s] = Rsouth + Rhalf + 0,
	[Xsand_stone_2_s] = Rsouth + Rhalf + 1,
};

/* THIS FILE AUTOMATICALLY GENERATED */

/* ---------------------------------------------------------------------- */

/* hook into sdl */

#define x11_game_clear no_x11_game_clear
#define x11_game_object no_x11_game_object
#define audio_open no_audio_open
#define audio_write no_audio_write
#define audio_close no_audio_close

#include "sdl.c"

#undef x11_game_clear
#undef x11_game_object
#undef audio_open
#undef audio_write
#undef audio_close

#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_mixer.h>

#include <string.h>
#include <stdio.h>
#include <errno.h>

/* ---------------------------------------------------------------------- */

/* handle experimental graphics */

short anim_frame;
short anim_rand[CAVE_WIDTH + 8][CAVE_HEIGHT + 4];
short anim_zero[CAVE_WIDTH + 8][CAVE_HEIGHT + 4];

void anim_update(struct LOGIC *lev)
{
	int x, y;
	for(x = lev->cave_left; x <= lev->cave_right; x++) for(y = lev->cave_top; y <= lev->cave_bottom; y++) {

/* copy animation frame for moving objects */

		short r = anim_rand[x][y];

		switch(lev->cave[x][y]) {
		case Yandroid_nB: if(lev->cave[x][y-1] == Yandroid_n) anim_rand[x][y-1] = r; break;
		case Yandroid_neB: if(lev->cave[x+1][y-1] == Yandroid_ne) anim_rand[x+1][y-1] = r; break;
		case Yandroid_eB: if(lev->cave[x+1][y] == Yandroid_e) anim_rand[x+1][y] = r; break;
		case Yandroid_seB: if(lev->cave[x+1][y+1] == Yandroid_se) anim_rand[x+1][y+1] = r; break;
		case Yandroid_sB: if(lev->cave[x][y+1] == Yandroid_s) anim_rand[x][y+1] = r; break;
		case Yandroid_swB: if(lev->cave[x-1][y+1] == Yandroid_sw) anim_rand[x-1][y+1] = r; break;
		case Yandroid_wB: if(lev->cave[x-1][y] == Yandroid_w) anim_rand[x-1][y] = r; break;
		case Yandroid_nwB: if(lev->cave[x-1][y-1] == Yandroid_nw) anim_rand[x-1][y-1] = r; break;
		case Yeater_nB: if(lev->cave[x][y-1] == Yeater_n) anim_rand[x][y-1] = r; break;
		case Yeater_eB: if(lev->cave[x+1][y] == Yeater_e) anim_rand[x+1][y] = r; break;
		case Yeater_sB: if(lev->cave[x][y+1] == Yeater_s) anim_rand[x][y+1] = r; break;
		case Yeater_wB: if(lev->cave[x-1][y] == Yeater_w) anim_rand[x-1][y] = r; break;
		case Yalien_nB: if(lev->cave[x][y-1] == Yalien_n) anim_rand[x][y-1] = r; break;
		case Yalien_eB: if(lev->cave[x+1][y] == Yalien_e) anim_rand[x+1][y] = r; break;
		case Yalien_sB: if(lev->cave[x][y+1] == Yalien_s) anim_rand[x][y+1] = r; break;
		case Yalien_wB: if(lev->cave[x-1][y] == Yalien_w) anim_rand[x-1][y] = r; break;
		case Ybug_nB: if(lev->cave[x][y-1] == Ybug_n) anim_rand[x][y-1] = r; break;
		case Ybug_eB: if(lev->cave[x+1][y] == Ybug_e) anim_rand[x+1][y] = r; break;
		case Ybug_sB: if(lev->cave[x][y+1] == Ybug_s) anim_rand[x][y+1] = r; break;
		case Ybug_wB: if(lev->cave[x-1][y] == Ybug_w) anim_rand[x-1][y] = r; break;
		case Ytank_nB: if(lev->cave[x][y-1] == Ytank_n) anim_rand[x][y-1] = r; break;
		case Ytank_eB: if(lev->cave[x+1][y] == Ytank_e) anim_rand[x+1][y] = r; break;
		case Ytank_sB: if(lev->cave[x][y+1] == Ytank_s) anim_rand[x][y+1] = r; break;
		case Ytank_wB: if(lev->cave[x-1][y] == Ytank_w) anim_rand[x-1][y] = r; break;
		case Yemerald_sB: if(lev->cave[x][y+1] == Yemerald_s) anim_rand[x][y+1] = r; break;
		case Yemerald_eB: if(lev->cave[x+1][y] == Yemerald_e) anim_rand[x+1][y] = r; break;
		case Yemerald_wB: if(lev->cave[x-1][y] == Yemerald_w) anim_rand[x-1][y] = r; break;
		case Ydiamond_sB: if(lev->cave[x][y+1] == Ydiamond_s) anim_rand[x][y+1] = r; break;
		case Ydiamond_eB: if(lev->cave[x+1][y] == Ydiamond_e) anim_rand[x+1][y] = r; break;
		case Ydiamond_wB: if(lev->cave[x-1][y] == Ydiamond_w) anim_rand[x-1][y] = r; break;
		case Ystone_sB: if(lev->cave[x][y+1] == Ystone_s) anim_rand[x][y+1] = r; break;
		case Ystone_eB: if(lev->cave[x+1][y] == Ystone_e) anim_rand[x+1][y] = r; break;
		case Ystone_wB: if(lev->cave[x-1][y] == Ystone_w) anim_rand[x-1][y] = r; break;
		case Ybomb_sB: if(lev->cave[x][y+1] == Ybomb_s) anim_rand[x][y+1] = r; break;
		case Ybomb_eB: if(lev->cave[x+1][y] == Ybomb_e) anim_rand[x+1][y] = r; break;
		case Ybomb_wB: if(lev->cave[x-1][y] == Ybomb_w) anim_rand[x-1][y] = r; break;
		case Ynut_sB: if(lev->cave[x][y+1] == Ynut_s) anim_rand[x][y+1] = r; break;
		case Ynut_eB: if(lev->cave[x+1][y] == Ynut_e) anim_rand[x+1][y] = r; break;
		case Ynut_wB: if(lev->cave[x-1][y] == Ynut_w) anim_rand[x-1][y] = r; break;
		case Yspring_sB: if(lev->cave[x][y+1] == Yspring_s) anim_rand[x][y+1] = r; break;
		case Yspring_eB: if(lev->cave[x+1][y] == Yspring_e) anim_rand[x+1][y] = r; break;
		case Yspring_wB: if(lev->cave[x-1][y] == Yspring_w) anim_rand[x-1][y] = r; break;
		case Yspring_alien_eB: if(lev->cave[x+1][y] == Yspring_alien_e) anim_rand[x+1][y] = r; break;
		case Yspring_alien_wB: if(lev->cave[x-1][y] == Yspring_alien_w) anim_rand[x-1][y] = r; break;
		case Yballoon_nB: if(lev->cave[x][y-1] == Yballoon_n) anim_rand[x][y-1] = r; break;
		case Yballoon_eB: if(lev->cave[x+1][y] == Yballoon_e) anim_rand[x+1][y] = r; break;
		case Yballoon_sB: if(lev->cave[x][y+1] == Yballoon_s) anim_rand[x][y+1] = r; break;
		case Yballoon_wB: if(lev->cave[x-1][y] == Yballoon_w) anim_rand[x-1][y] = r; break;
		case Xdrip_1_sB: if(lev->cave[x][y+1] == Xdrip_1_s) anim_rand[x][y+1] = r; break;
		case Xdrip_2_sB: if(lev->cave[x][y+1] == Xdrip_2_s) anim_rand[x][y+1] = r; break;

/* zero animation frame for still objects */

		case Xboom_android:
		case Xboom_1:
		case Xpop:
		case Xsplash_e: case Xsplash_w:
		case Ygrass_nB: case Ygrass_eB:
		case Ygrass_sB: case Ygrass_wB:
		case Ydirt_nB: case Ydirt_eB:
		case Ydirt_sB: case Ydirt_wB:
		case Yeater_stone: case Yeater_spring:
		case Yalien_stone: case Yalien_spring:
		case Ybug_w_n: case Ybug_n_e:
		case Ybug_e_s: case Ybug_s_w:
		case Ybug_e_n: case Ybug_s_e:
		case Ybug_w_s: case Ybug_n_w:
		case Ybug_stone_n: case Ybug_stone_e:
		case Ybug_stone_s: case Ybug_stone_w:
		case Ybug_spring_n: case Ybug_spring_e:
		case Ybug_spring_s: case Ybug_spring_w:
		case Ytank_w_n: case Ytank_n_e:
		case Ytank_e_s: case Ytank_s_w:
		case Ytank_e_n: case Ytank_s_e:
		case Ytank_w_s: case Ytank_n_w:
		case Ytank_stone_n: case Ytank_stone_e:
		case Ytank_stone_s: case Ytank_stone_w:
		case Ytank_spring_n: case Ytank_spring_e:
		case Ytank_spring_s: case Ytank_spring_w:
		case Yemerald_shine: case Yemerald_space:
		case Ydiamond_shine: case Ydiamond_space:
		case Ydiamond_stone:
		case Ybomb_space:
		case Ynut_stone:
		case Yspring_alien_e: case Yspring_alien_w:
		case Ydynamite_space: case Xdynamite_1:
		case Xdrip:
		case Ybumper:
		case Yslide_ns: case Yslide_ew:
			anim_rand[x][y] = rand();
			anim_zero[x][y] = -anim_frame;
			break;
		}
	}
}

short graphics[XMAX][parameter_max];

SDL_Surface *image_data[100];

char *image_name[100];
int image_max = 1;

void anim_render(struct LOGIC *lev, int scn_x, int scn_y, int lev_x, int lev_y)
{
	int tile = lev->cave[lev_x][lev_y];
	SDL_Surface *srcPixmap = image_data[graphics[tile][0]]; /* XXX brain-dead */

	/* fallback to builtin graphics */

	SDL_Rect srcR, dstR;
	dstR.x = scn_x * 16 * scale_x; dstR.y = scn_y * 16 * scale_y;
	if(srcPixmap == 0) {
		tile = object_map[tile][lev->frame];
		srcR.x = (tile / GFX_HEIGHT) * 16 * scale_x; srcR.w = 16 * scale_x;
		srcR.y = (tile % GFX_HEIGHT) * scale_y; srcR.h = 16 * scale_y;
		SDL_BlitSurface(objectPixmap, &srcR, screenPixmap, &dstR);
		return;
	}

	/* compute animation frame rubbish */

	srcR.x = graphics[tile][Pposx] * 32; srcR.w = 32;
	srcR.y = graphics[tile][Pposy] * 32; srcR.h = 32;

	int anim = (graphics[tile][Psync] > 0 ? -anim_rand[lev_x][lev_y] : 0);

	int delay = (graphics[tile][Pdelay] > 0 ? graphics[tile][Pdelay] : 1);
	int frames = (graphics[tile][Pframes] > 0 ? graphics[tile][Pframes] : 1);

	switch(graphics[tile][Panim]) {
	case Qloop:
		anim += anim_rand[lev_x][lev_y] + (anim_frame / delay);
		anim &= 32767;
		anim %= frames;
		break;
	case Qloop_reverse:
		anim += anim_rand[lev_x][lev_y] + (anim_frame / delay);
		anim &= 32767;
		anim %= frames;
		anim = frames - 1 - anim;
		break;
	case Qlinear:
		anim += (anim_zero[lev_x][lev_y] + anim_frame) / delay;
		anim &= 32767;
		if(anim > frames - 1) anim = frames - 1;
		break;
	case Qlinear_reverse:
		anim += (anim_zero[lev_x][lev_y] + anim_frame) / delay;
		anim &= 32767;
		if(anim > frames - 1) anim = frames - 1;
		anim = frames - 1 - anim;
		break;
	case Qpingpong:
		if(frames > 1) {
			anim += anim_rand[lev_x][lev_y] + (anim_frame / delay);
			anim &= 32767;
			anim %= frames * 2 - 2;
			if(anim > frames - 1) anim = frames * 2 - 2 - anim;
		}
		break;
	case Qpingpong2:
		if(frames > 1) {
			anim += anim_rand[lev_x][lev_y] + (anim_frame / delay);
			anim &= 32767;
			anim %= frames * 2;
			if(anim > frames - 1) anim = frames * 2 - 1 - anim;
		}
		break;
	case Qrandom:
		anim += anim_rand[lev_x][lev_y];
		anim &= 32767;
		anim %= frames;
		break;
	}
	int offset = (graphics[tile][Poffset] > 0 ? graphics[tile][Poffset] : 32);
	int stride = (graphics[tile][Pstride] > 0 ? graphics[tile][Pstride] * 32 : srcPixmap->w);

	srcR.x += anim * offset; /* from frame to pixel */
	srcR.y += (srcR.x / stride) * 32; /* wrap */
	srcR.x %= stride;

	/* compute pixel position for moving between tiles */

	int move = anim_movement[tile];
	int pixel = (lev->frame + 1) * 4 + (move & 15) * 32;

	if(move & Rhalf) pixel /= 2; /* half speed */
	if(move & Rquarter) pixel /= 4; /* quarter speed */

	if(move & Rnorth) {
		if(move & Rspace) {
			srcR.y += pixel;
			srcR.h -= pixel;
		} else {
			dstR.y += 32 - pixel;
			srcR.h -= 32 - pixel;
		}
	}
	if(move & Reast) {
		if(move & Rspace) {
			dstR.x += pixel;
			srcR.w -= pixel;
		} else {
			srcR.x += 32 - pixel;
			srcR.w -= 32 - pixel;
		}
	}
	if(move & Rsouth) {
		if(move & Rspace) {
			dstR.y += pixel;
			srcR.h -= pixel;
		} else {
			srcR.y += 32 - pixel;
			srcR.h -= 32 - pixel;
		}
	}
	if(move & Rwest) {
		if(move & Rspace) {
			srcR.x += pixel;
			srcR.w -= pixel;
		} else {
			dstR.x += 32 - pixel;
			srcR.w -= 32 - pixel;
		}
	}

	SDL_BlitSurface(srcPixmap, &srcR, screenPixmap, &dstR);
}

void x11_game_object(struct LOGIC *lev)
{
	if(lev->frame == 0) anim_update(lev);

/* always redraw the entire screen. slow, but correct. */

	SDL_Rect r;
	r.x = scn_pixel_left * scale_x; r.w = VIEW_WIDTH * scale_x;
	r.y = scn_pixel_top * scale_y; r.h = VIEW_HEIGHT * scale_y;
	SDL_FillRect(screenPixmap, &r, 0);

	int scn_x, lev_x;
	int scn_y, lev_y;

	scn_x = scn_pixel_left / 16;
	for(lev_x = lev->view_left; lev_x <= lev->view_right; lev_x++) {
		scn_y = scn_pixel_top / 16;
		for(lev_y = lev->view_top; lev_y <= lev->view_bottom; lev_y++) {
			anim_render(lev, scn_x, scn_y, lev_x, lev_y);
			scn_y++;
		}
		scn_x++;
	}
	anim_frame++;
}

void config_read(void);

void x11_game_clear(void)
{
	static char once = 1; if(once) { once = 0; config_read(); }

	int x, y;
	for(x = 0; x < CAVE_WIDTH + 8; x++) for(y = 0; y < CAVE_HEIGHT + 4; y++) {
		anim_rand[x][y] = rand();
		anim_zero[x][y] = -anim_frame;
	}
}

/* ---------------------------------------------------------------------- */

/* handle experimental audio */

Mix_Chunk *sounds_mix[SOUND_MAX];

int audio_open(void)
{
	if(Mix_OpenAudio(MIX_DEFAULT_FREQUENCY, MIX_DEFAULT_FORMAT, MIX_DEFAULT_CHANNELS, BUFFER_SIZE) == -1) {
		fprintf(stderr, "%s[%s] %s: %s\n", global, local, "failed to open audio mixer", Mix_GetError());
		return(1);
	}

	int freq;
	Uint16 format;
	int channels;
	Mix_QuerySpec(&freq, &format, &channels);

	/* convert builtin sounds to mixer format */

	int i;
	for(i = 0; i < SOUND_MAX; i++) {
		SDL_AudioCVT cvt;
		SDL_BuildAudioCVT(&cvt, AUDIO_U8, 1, 8000, format, channels, freq);
		cvt.len = sounds_length[i];
		cvt.buf = malloc(cvt.len * cvt.len_mult);
		if(cvt.buf == 0) {
			fprintf(stderr, "%s[%s] %s (%d)\n", global, local, "failed to allocate sounds", cvt.len * cvt.len_mult);
			return(1);
		}
		register const unsigned char *in = sounds_data[i];
		register Uint8 *out = cvt.buf;
		register int len = cvt.len;
		do *out++ = (ulaw_to_linear[*in++] + 32768) >> 8; while(--len);
		SDL_ConvertAudio(&cvt);

		sounds_mix[i] = Mix_QuickLoad_RAW(cvt.buf, cvt.len * cvt.len_ratio);
	}

	return(0);
}

short sounds[SOUND_MAX];

Mix_Chunk *wave_data[40];

char *wave_name[40];
int wave_max = 1;

void audio_write(struct LOGIC *lev)
{
	mix_count = 0;
	int n;
	for(n = 0; n < SOUND_MAX; n++) if(lev->sound[n]) {
		Mix_Chunk *chunk = wave_data[sounds[n]];
		if(chunk == 0) chunk = sounds_mix[n]; /* fallback to builtin sounds */
		if(chunk == 0) continue;

		while(mix_count < MIXER_MAX) {
			if(!Mix_Playing(mix_count)) break; /* check if channel is available */
			if(n <= mix_play[mix_count]) break; /* check sound priority */
			mix_count++;
		}
		while(mix_count < MIXER_MAX) {
			Mix_PlayChannel(mix_count, chunk, 0);
			mix_play[mix_count++] = n;
			if(n >= SOUND_boom) break;
		}
	}
}

int audio_close(void)
{
	Mix_CloseAudio();
	return(0);
}

/* ---------------------------------------------------------------------- */

/* parse graphics and sounds config files */

short element_len[element_max];
short action_len[action_max];
short direction_len[direction_max];
short parameter_len[parameter_max];

void config_lookup(const char *buffer, int *ret_element, int *ret_action, int *ret_direction, int *ret_parameter)
{
	int buffer_len = strlen(buffer);

	int element, action, direction, parameter;

	for(parameter = 1; parameter < parameter_max; parameter++) {
		const char *suffix = parameter_name[parameter];
		const int suffix_len = parameter_len[parameter];
		if(buffer_len >= suffix_len && strncmp(buffer + buffer_len - suffix_len, suffix, suffix_len) == 0) { buffer_len -= suffix_len; break; }
	}
	if(parameter >= parameter_max) parameter = 0;

	for(direction = 1; direction < direction_max; direction++) {
		const char *suffix = direction_name[direction];
		const int suffix_len = direction_len[direction];
		if(buffer_len >= suffix_len && strncmp(buffer + buffer_len - suffix_len, suffix, suffix_len) == 0) { buffer_len -= suffix_len; break; }
	}
	if(direction >= direction_max) direction = 0;

	for(action = 1; action < action_max; action++) {
		const char *suffix = action_name[action];
		const int suffix_len = action_len[action];
		if(buffer_len >= suffix_len && strncmp(buffer + buffer_len - suffix_len, suffix, suffix_len) == 0) { buffer_len -= suffix_len; break; }
	}
	if(action >= action_max) action = 0;

	for(element = 1; element < element_max; element++) {
		const char *prefix = element_name[element];
		const int prefix_len = element_len[element];
		if(buffer_len == prefix_len && strncmp(buffer, prefix, prefix_len) == 0) { buffer_len -= prefix_len; break; }
	}
	if(element >= element_max) element = 0;

	*ret_element = element;
	*ret_action = action;
	*ret_direction = direction;
	*ret_parameter = parameter;
}

/* parse config file and set parameters for all tiles */

void config_graphics(char *file)
{
	FILE *fp;
	if(fp = fopen(file, "r"), fp == 0) {
		fprintf(stderr, "%s[%s] %s: %s: %s\n", global, local, file, "failed to open graphics config file", strerror(errno));
		return;
	}
	char buffer[400];
	while(fgets(buffer, sizeof(buffer), fp) != 0) {
		char *command = strtok(buffer, ":=");
		char *value = strtok(0, "");
		if(command == 0 || value == 0) continue;
		command = strtok(command, "# \t\r\n");
		value = strtok(value, "# \t\r\n");
		if(command == 0 || value == 0) continue;

		/* parse element name */

		int element, action, direction, parameter;

		config_lookup(command, &element, &action, &direction, &parameter);

		if(element == 0) continue; /* not used in Emerald Mine */

		/* parse numeric values */

		int num = atoi(value);
		if(strstr(value, "false") != 0) num = 0;
		if(strstr(value, "true") != 0) num = 1;

		if(parameter == Panim) {
			num = 0;
			if(strstr(value, "loop") != 0) num = Qloop;
			if(strstr(value, "linear") != 0) num = Qlinear;
			if(strstr(value, "reverse") != 0) num = (num == Qloop ? Qloop_reverse : Qlinear_reverse);
			if(strstr(value, "pingpong") != 0) num = Qpingpong;
			if(strstr(value, "pingpong2") != 0) num = Qpingpong2; /* XXX brain-dead */
			if(strstr(value, "random") != 0) num = Qrandom;
		}

		/* add image file */

		if(parameter == 0) { /* XXX brain-dead */
			for(num = 1; num < image_max; num++) {
				if(strcmp(image_name[num], value) == 0) break;
			}
			if(num >= image_max) {
				if(image_max < sizeof(image_name) / sizeof(*image_name)) {
					image_name[image_max] = strdup(value);
					if(image_name[image_max] != 0) image_max++;
				}
			}
			if(num >= image_max) num = 0;
		}

		/* set parameters */

		int n;
		for(n = 0; n < XMAX; n++) {
			if(graphics_name[n][0] == element) {
				if(graphics_name[n][1] == action || action == 0) {
					if(graphics_name[n][2] == direction || direction == 0) {
						graphics[n][parameter] = num;
					}
				}
			}
		}
	}
	fclose(fp);
}

/* parse config file and set filenames for all sounds */

void config_sounds(char *file)
{
	FILE *fp;
	if(fp = fopen(file, "r"), fp == 0) {
		fprintf(stderr, "%s[%s] %s: %s: %s\n", global, local, file, "failed to open sounds config file", strerror(errno));
		return;
	}
	char buffer[400];
	while(fgets(buffer, sizeof(buffer), fp) != 0) {
		char *command = strtok(buffer, ":=");
		char *value = strtok(0, "");
		if(command == 0 || value == 0) continue;
		command = strtok(command, "# \t\r\n");
		value = strtok(value, "# \t\r\n");
		if(command == 0 || value == 0) continue;

		/* parse sound name */

		int n;
		for(n = 0; n < SOUND_MAX; n++) {
			if(strcmp(command, sounds_name[n]) == 0) break;
		}
		if(n >= SOUND_MAX) continue; /* not used in Emerald Mine */

		/* add wave file */

		int num;
		for(num = 1; num < wave_max; num++) {
			if(strcmp(wave_name[num], value) == 0) break;
		}
		if(num >= wave_max) {
			if(wave_max < sizeof(wave_name) / sizeof(*wave_name)) {
				wave_name[wave_max] = strdup(value);
				if(wave_name[wave_max] != 0) wave_max++;
			}
		}
		if(num >= wave_max) num = 0;

		sounds[n] = num;
	}
	fclose(fp);
}

void config_read(void)
{
	SDL_WM_SetCaption("X11 Emerald Mine [experimental]", global);

	int n;

	/* caching config string lengths makes config_lookup four times faster */

	for(n = 1; n < element_max; n++) element_len[n] = strlen(element_name[n]);
	for(n = 1; n < action_max; n++) action_len[n] = strlen(action_name[n]);
	for(n = 1; n < direction_max; n++) direction_len[n] = strlen(direction_name[n]);
	for(n = 1; n < parameter_max; n++) parameter_len[n] = strlen(parameter_name[n]);

	fputs("\n", stderr);

	config_graphics("graphicsinfo.conf");
	config_sounds("soundsinfo.conf");

	for(n = 1; n < image_max; n++) {
		fprintf(stderr, "\"%s\" ", image_name[n]);
		image_data[n] = IMG_Load(image_name[n]);
	}
	for(n = 1; n < wave_max; n++) {
		fprintf(stderr, "\"%s\" ", wave_name[n]);
		wave_data[n] = Mix_LoadWAV(wave_name[n]);
	}
	fputs(".\n", stderr);

/* convert surfaces to the display format, which may be TrueColour, for higher than 8 bit resolution images */

	SDL_Surface *pixmap;
	if(pixmap = SDL_DisplayFormat(screenPixmap), pixmap != 0) {
		SDL_FreeSurface(screenPixmap); screenPixmap = pixmap;
	}
	for(n = 1; n < image_max; n++) {
		if(image_data[n] != 0) {
			if(pixmap = SDL_DisplayFormat(image_data[n]), pixmap != 0) {
				SDL_FreeSurface(image_data[n]); image_data[n] = pixmap;
			}
		}
	}
}
